OSFileHandle subclass:#UnixFileDescriptorHandle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'OS-Unix'
!

!UnixFileDescriptorHandle primitiveDefinitions!
%{
#include <stdio.h>
%}

! !


!UnixFileDescriptorHandle methodsFor:'finalization'!

disposed
    "a filedescriptor was garbage collected - close the underlying file"

%{
    INT fd = (INT)(__externalAddressVal(self));

    if (fd > 0) {
        __externalAddressVal(self) = (OBJ)-1;
        close(fd);
    }
%}.

! !

!UnixFileDescriptorHandle methodsFor:'release'!

close
    "close the file"

%{
    INT fd = (INT)(__externalAddressVal(self));

    if (fd > 0) {
        __externalAddressVal(self) = (OBJ)-1;
        close(fd);
    }
%}.
    Lobby unregister:self


! !

!UnixFileDescriptorHandle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/UnixFileDescriptorHandle.st,v 1.1 1999-09-18 11:11:04 cg Exp $'
! !
